#pragma once

#include "CoreMinimal.h"
#include "K40SecurityCorridorCameraDolly.h"
#include "Templates/SubclassOf.h"
#include "K40SecurityCorridorKillerCameraDolly.generated.h"

class UAnimInstance;
class AK40SecurityCorridorHusk;
class ASurvivor;

UCLASS(Blueprintable)
class AK40SecurityCorridorKillerCameraDolly : public AK40SecurityCorridorCameraDolly
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UAnimInstance> _survivorHuskAnimInstanceClass;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TMap<ASurvivor*, AK40SecurityCorridorHusk*> _survivorHusks;

protected:
	UFUNCTION(BlueprintPure)
	AK40SecurityCorridorHusk* GetSurvivorHusk() const;

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSurvivorHuskCreated(AK40SecurityCorridorHusk* survivorHusk);

public:
	AK40SecurityCorridorKillerCameraDolly();
};

FORCEINLINE uint32 GetTypeHash(const AK40SecurityCorridorKillerCameraDolly) { return 0; }
